/*
integrit - file integrity verification system
Copyright (C) 2000 Ed Cashin

You can redistribute this program and/or modify it under the terms of
the Artistic License as published by the Open Source Initiative,
currently at the following URL:

    http://www.opensource.org/licenses/artistic-license.html

THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.

*/
#include	<config.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<limits.h>
#include	<errno.h>
#include	"checkset.h"
#include	"elcerror.h"
#include	"elcerror_p.h"
#include	"checkset_p.h"
#ifdef		ELC_FIND_LEAKS
#include	"leakfind.h"
#endif

void checkset_init(checkset c, size_t n)
{
    if (n > CHECKSET_MAXLEN)
      DIE("too many members for checkset");
    c[0]	 = n;
    c[1]	 = 0;
}

void checkset_show(FILE *out, checkset c)
{
    int		i;

    if (CHECKSET_GETIGNORE(c))
      putc('!', out);
    if (CHECKSET_GETNOCHILD(c))
      putc('=', out);

    for (i = 0; i < CHECKSET_LEN(c); ++i)
      putc(CHECKSET_SWITCH_AT(c, i), out);
}

checkset checkset_new(size_t n)
{
    checkset	c	 = malloc(sizeof(*c) * (n+2));
    if (! c)
      DIE("malloc new checkset");
    c[0]	 = n;		/* first byte is number of switches */
    c[1]	 = 0;		/* second byte is for non-inheriting flags */
    return c;
}

void checkset_free(checkset c)
{
    free(c);
}
